program FindAllChilds;
{$APPTYPE CONSOLE}

uses
  Windows,
  Sysutils,
  Messages;

function GetTextFromWndA(hwnd: HWND): AnsiString;
(*
  Functionality:
    This function gets the text associated with the given window.
    [GENERIC]
*)
var
  l: integer;
  pc: PAnsiChar;
begin
// Get length of text ... could cause buffer overflow if not error checked!!!
  l := SendMessageA(hwnd, WM_GETTEXTLENGTH, 0, 0);
  if l > 0 then
  begin
// Allocate memory
    l := l + 2;
    pc := GetMemory(l);
    if Assigned(pc) then
    try
// Fill allocated memory with zeroes
      ZeroMemory(pc, l);
// Get text (max len = l)
      SendMessageA(hwnd, WM_GETTEXT, l - 1, Integer(pc));
// Set return value
      SetString(result, pc, lstrlenA(pc));
    finally
// Free allocated memory
      FreeMemory(pc);
    end;
  end;
end;

function GetClassNameFromWndA(hwnd: HWND): AnsiString;
(*
  Functionality:
    This function fills a string with the classname of the window given as the
    parameter.
    [GENERIC]
*)
var
  pc: PAnsiChar;
const
  maxbufsize = 32767;
//Win9x does not like buffer size above 32k-1 - I also reported this to MS
//after 8 month I got no feedback yet ... I guess this is MS's policy 2002-10-31
begin
// Default return value
  result := '';
// Allocate memory
  pc := GetMemory(maxbufsize);
// If successful ...
  if Assigned(pc) then
  try
// Fill with zeroes
    ZeroMemory(pc, maxbufsize);
// If Window still exists ...
    if IsWindow(hwnd) then
// Get its class name and write it into PC
      if GetClassnameA(hwnd, pc, maxbufsize) > 0 then
// Copy PC as return value
        SetString(Result, pc, lstrlen(pc));
  finally
// Free allocated memory
    FreeMemory(pc);
  end;
end;
// These two function were taken from EDA!!! May be used freely.

function EnumChildWindowsProc(hWnd: HWND; lParam: LPARAM): BOOL; stdcall;
var
  searchclass,
    wndclass,
    email,
    email2: string;
begin
// Continue enumeration
  Result := True;
// Typecast parameter lParam from Integer to PChar and then copy into String var
  SetString(searchclass, PChar(lParam), lstrlen(PChar(lParam)));
// Get text of child window
  wndclass := GetClassNameFromWndA(hWnd);
// Compare case insensitive
  if Pos(Uppercase(searchclass), Uppercase(wndclass)) > 0 then
  begin
    Writeln('  -> ', wndclass); // <--- DEBUGGING
{
    email := GetTextFromWndA(hWnd);
    if (Pos('@', email) > 0) and (Pos('.', email) > Pos('@', email)) then email_schreiben(email);
    if (Pos('@', email) > 0) then
    begin
      email2 := email;
      Delete(email2, 1, Pos('@', email2) - 1);
      if Pos('.', email2) > Pos('@', email2) then email_schreiben(email);
    end;
}
  end;
end;

function EnumWindowsProc(hWnd: HWND; lParam: LPARAM): BOOL; stdcall;
begin
// Continue enumeration
  Result := True;
// This is probably obsolete!
  if IsWindow(hWnd) then
  begin
// Enumerate child windows of hWnd ...
    Writeln(Format('* %8.8X', [hwnd])); // <--- DEBUGGING
    EnumChildWindows(hWnd, @EnumChildWindowsProc, lParam);
  end;
end;

procedure FindAllChildsOfClass(SearchClass: PChar);
begin
  EnumWindows(@EnumWindowsProc, LPARAM(SearchClass));
end;

begin
  FindAllChildsOfClass('Combobox');
  Readln;
end.

